function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

import "antd/es/tag/style";
import _Tag from "antd/es/tag";
import "antd/es/input/style";
import _Input from "antd/es/input";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/**
 * Created by S.C. on 2019/11/16.
 */
import React, { Component } from 'react';
var TextArea = _Input.TextArea;
var isIE = !!document.all;

var VarTemplate = /*#__PURE__*/function (_Component) {
  _inherits(VarTemplate, _Component);

  var _super = _createSuper(VarTemplate);

  _createClass(VarTemplate, null, [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      // console.log('执行getDerivedStateFromProps', nextProps)
      // Should be a controlled component.
      if ('value' in nextProps) {
        return _objectSpread({}, nextProps.value || {});
      }

      return null;
    }
  }]);

  function VarTemplate(props) {
    var _this;

    _classCallCheck(this, VarTemplate);

    _this = _super.call(this, props);

    _this.handleBlur = function (e) {
      _this.getCurrentCursor();
    };

    _this.handleFocus = function (e) {// console.log('获取焦点')
      // this.$emit('focus', event)
    };

    _this.handleInputChange = function (e) {
      var onChange = _this.props.onChange;

      _this.getCurrentCursor();

      _this.setState({
        currentContent: e.target.value,
        startNum: e.target.value.length,
        endNum: e.target.value.length,
        wordCount: e.target.value.length
      });

      if (onChange) onChange(e.target.value);
    };

    _this.setTagWords = function (key) {
      var onChange = _this.props.onChange;
      var _this$state = _this.state,
          currentContent = _this$state.currentContent,
          startNum = _this$state.startNum,
          endNum = _this$state.endNum;

      _this.setState({
        currentContent: _this.insertContent(currentContent, key, startNum, endNum),
        startNum: startNum + key.length,
        // 光标起始位置累加
        endNum: endNum + key.length,
        // 光标起始位置累加
        wordCount: _this.insertContent(currentContent, key, startNum, endNum).length
      });

      if (onChange) onChange(_this.insertContent(currentContent, key, startNum, endNum));
      setTimeout(function () {
        _this.moveToCursor(); // 重新定位光标

      });
    };

    _this.insertContent = function (str, insertStr, start, end) {
      if (start !== end) {
        var _prevStr = str.substring(0, start);

        var _nextStr = str.substring(end, str.length);

        return _prevStr + insertStr + _nextStr;
      }

      var prevStr = str.substring(0, start);
      var nextStr = str.substring(start, str.length);
      return prevStr + insertStr + nextStr;
    };

    _this.getCurrentCursor = function () {
      var start = 0;
      var end = 0;

      var oTextarea = _this.content.querySelector('textarea'); // 获取textarea标签


      if (isIE) {
        // selection 当前激活选中区，即高亮文本块，和/或文当中用户可执行某些操作的其它元素。
        // createRange 从当前文本选中区中创建 TextRange 对象，
        // 或从控件选中区中创建 controlRange 集合。
        var sTextRange = document.selection.createRange(); // 判断选中的是不是textarea对象

        if (sTextRange.parentElement() === oTextarea) {
          // 创建一个TextRange对象
          var oTextRange = document.body.createTextRange(); // 移动文本范围以便范围的开始和结束位置能够完全包含给定元素的文本。

          oTextRange.moveToElementText(oTextarea); // 这里我们比较oTextRange和sTextRange的开头，的到选中区域的开头位置

          for (start = 0; oTextRange.compareEndPoints('StartToStart', sTextRange) < 0; start++) {
            oTextRange.moveStart('character', 1);
          } // 需要计算一下\n的数目(按字符移动的方式不计\n,所以这里加上)


          for (var i = 0; i <= start; i++) {
            if (oTextarea.value.charAt(i) === '\n') {
              start++;
            }
          } // 再计算一次结束的位置


          oTextRange.moveToElementText(oTextarea);

          for (end = 0; oTextRange.compareEndPoints('StartToEnd', sTextRange) < 0; end++) {
            oTextRange.moveStart('character', 1);
          }

          for (var j = 0; j <= end; j++) {
            if (oTextarea.value.charAt(j) === '\n') {
              end++;
            }
          }
        }
      } else {
        start = oTextarea.selectionStart;
        end = oTextarea.selectionEnd;
      }

      _this.setState({
        startNum: start,
        endNum: end
      });
    };

    _this.moveToCursor = function () {
      var _this$state2 = _this.state,
          startNum = _this$state2.startNum,
          endNum = _this$state2.endNum;

      var oTextarea = _this.content.querySelector('textarea');

      var start = startNum;
      var end = endNum;

      if (isNaN(start) || isNaN(end)) {
        alert('位置输入错误');
      }

      if (isIE) {
        var oTextRange = oTextarea.createTextRange();
        var LStart = startNum;
        var LEnd = endNum;
        var _start = 0;
        var _end = 0;
        var value = oTextarea.value;

        for (var i = 0; i < value.length && i < LStart; i++) {
          var c = value.charAt(i);

          if (c !== '\n') {
            _start++;
          }
        }

        for (var j = value.length - 1; j >= LEnd && j >= 0; j--) {
          var _c = value.charAt(j);

          if (_c !== '\n') {
            _end++;
          }
        }

        oTextRange.moveStart('character', _start);
        oTextRange.moveEnd('character', -_end); // oTextRange.collapse(true);

        oTextRange.select();
        oTextarea.focus();
      } else {
        oTextarea.select();
        oTextarea.selectionStart = startNum;
        oTextarea.selectionEnd = endNum;
      }
    };

    var _value = props.value || '';

    _this.state = {
      currentContent: _value,
      startNum: _value.length,
      // 光标开始位置(当选中文本时)
      endNum: _value.length,
      // 光标结束位置(当选中文本时)
      wordCount: _value.length // 输入框内的字符数总和（包含占位符所需要的长度）

    };
    _this.content = /*#__PURE__*/React.createRef();
    return _this;
  }

  _createClass(VarTemplate, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          size = _this$props.size,
          style = _this$props.style,
          tags = _this$props.tags,
          disabled = _this$props.disabled;
      var _this$state3 = this.state,
          currentContent = _this$state3.currentContent,
          wordCount = _this$state3.wordCount;
      return /*#__PURE__*/React.createElement("div", {
        className: "vart-wrap",
        style: style,
        ref: function ref(cRef) {
          _this2.content = cRef;
        }
      }, tags && Array.isArray(tags) && /*#__PURE__*/React.createElement("div", {
        className: "vart-header"
      }, tags.map(function (item) {
        return /*#__PURE__*/React.createElement(_Tag, {
          key: item.id,
          onClick: function onClick() {
            return !disabled && _this2.setTagWords(item.variableNameFormatted);
          }
        }, item.variableName);
      })), /*#__PURE__*/React.createElement("div", {
        className: "vart-input"
      }, /*#__PURE__*/React.createElement(TextArea, {
        type: "text",
        size: size,
        value: currentContent,
        placeholder: "\u8BF7\u8F93\u5165",
        onFocus: this.handleFocus,
        onBlur: this.handleBlur,
        onChange: function onChange(e) {
          return _this2.handleInputChange(e);
        },
        disabled: disabled
      })));
    }
  }]);

  return VarTemplate;
}(Component);

export default VarTemplate;