import "antd/es/spin/style";
import _Spin from "antd/es/spin";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import './index.less';
import React from 'react';
import classNames from 'classnames';
import SplitterLayout from '../SplitterLayout';

var SubfieldContent = function SubfieldContent(props) {
  var _props$leftSiderWidth = props.leftSiderWidth,
      leftSiderWidth = _props$leftSiderWidth === void 0 ? 180 : _props$leftSiderWidth,
      leftSiderNode = props.leftSiderNode,
      children = props.children,
      className = props.className,
      style = props.style,
      leftSiderClassName = props.leftSiderClassName,
      _props$loading = props.loading,
      loading = _props$loading === void 0 ? false : _props$loading,
      loadingTip = props.loadingTip,
      splitterlayout = props.splitterlayout,
      splitterProps = props.splitterProps;
  return /*#__PURE__*/React.createElement("div", {
    className: classNames('spec-grid-content', loading ? 'spec-grid-content-loading' : '', className),
    style: style
  }, loading && /*#__PURE__*/React.createElement(_Spin, {
    spinning: loading,
    tip: loadingTip
  }), splitterlayout ? /*#__PURE__*/React.createElement(SplitterLayout, _extends({
    partClassNames: ["".concat(classNames('spec-grid-left', leftSiderClassName)), 'spec-grid-right'],
    primaryMinSize: leftSiderWidth || 180,
    primaryInitialSize: leftSiderWidth || 180
  }, splitterProps), /*#__PURE__*/React.createElement(React.Fragment, null, leftSiderNode), /*#__PURE__*/React.createElement(React.Fragment, null, children)) : /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: classNames('spec-grid-left', leftSiderClassName),
    style: {
      width: "".concat(leftSiderWidth || 180, "px")
    }
  }, leftSiderNode), /*#__PURE__*/React.createElement("div", {
    className: "spec-grid-right"
  }, children)));
};

export default SubfieldContent;