// 存储当前页面中所有菜单的涉及的功能代码，包括页面及按钮
export default {
  btnFuncCodes: [{
    name: '详情',
    code: 'codeBtnDetail',
    icon: 'eye'
  }, {
    name: '新增',
    code: 'codeBtnCreate',
    icon: 'plus'
  }, {
    name: '修改',
    code: 'codeBtnUpdate',
    icon: 'edit'
  }, {
    name: '删除',
    code: 'codeBtnDelete',
    icon: 'delete'
  }, {
    name: '导入',
    code: 'codeBtnImport',
    icon: 'upload'
  }, {
    name: '导出',
    code: 'codeBtnDownload',
    icon: 'download'
  }, {
    name: '查看',
    code: 'codeBtnView',
    icon: 'eye'
  }, {
    name: '功能授权',
    code: 'codeBtnAuthorize',
    icon: 'filter'
  }, {
    name: '数据授权',
    code: 'codeBtnAuthorizeData',
    icon: 'filter'
  }, {
    name: '添加',
    code: 'codeBtnAdd',
    icon: 'plus'
  }, {
    name: '下架',
    code: 'codeBtnDown',
    icon: 'plus'
  }, {
    name: '发布',
    code: 'codeBtnPublish',
    icon: 'plus'
  }, {
    name: '推荐设置',
    code: 'codeBtnSetRecommend',
    icon: 'plus'
  }, {
    name: '处理',
    code: 'codeBtnDispose',
    icon: 'plus'
  }, {
    name: '激活',
    code: 'codeBtnActivate',
    icon: 'plus'
  }, {
    name: '新增审批节点',
    // 工作流管理模块
    code: 'codeBtnApproval',
    icon: 'plus'
  }, {
    name: '设置',
    // 设置（报警全局）
    code: 'codeBtnSetting',
    icon: 'plus'
  }, {
    name: '启用',
    // 启用
    code: 'codeBtnUsing',
    icon: 'plus'
  }, {
    name: '停用',
    // 启用
    code: 'codeBtnStop',
    icon: 'plus'
  }, {
    name: '执行',
    code: 'codeBtnTrigger',
    icon: 'plus'
  }, {
    name: '恢复',
    code: 'codeBtnResume',
    icon: 'plus'
  }, {
    name: '指派',
    code: 'codeBtnAssign',
    icon: 'plus'
  }, {
    name: '匹配设备',
    code: 'codeBtnMatch'
  }, {
    name: '路线设计',
    code: 'codeBtnDesign'
  }],
  pageFuncCodes: [{
    name: '新增',
    code: 'codePageAdd'
  }, {
    name: '编辑',
    code: 'codePageEdit'
  }, {
    name: '详情',
    code: 'codePageDetail'
  }]
};