"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

require("./index.less");

require("./fonts/iconfont.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// 之后替换回来本地图标文件
// import { createFromIconfontCN } from '@ant-design/icons';
// 使用：
// import IconFont from '@/components/IconFont';
// <IconFont type='icon-demo' className='xxx-xxx' />
// export default Icon.createFromIconfontCN({ scriptUrl });
var SpecIcon = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var _props$type = props.type,
      type = _props$type === void 0 ? "colour" : _props$type,
      name = props.name,
      size = props.size,
      status = props.status,
      round = props.round,
      title = props.title,
      onClick = props.onClick,
      style = props.style,
      _props$prefix = props.prefix,
      prefix = _props$prefix === void 0 ? 'speci' : _props$prefix,
      _props$noPrefix = props.noPrefix,
      noPrefix = _props$noPrefix === void 0 ? false : _props$noPrefix,
      className = props.className,
      otherProps = _objectWithoutProperties(props, ["type", "name", "size", "status", "round", "title", "onClick", "style", "prefix", "noPrefix", "className"]);

  var extraClassName = '';
  if (status) extraClassName += " is-".concat(status);
  var fontStyle = {};

  if (size) {
    fontStyle = {
      fontSize: "".concat(size, "px")
    };
  }

  (0, _react.useEffect)(function () {// createFromIconfontCN({
    //   // scriptUrl: '//at.alicdn.com/t/font_1771828_qn47nt5qy2n.js', // 暂时使用线上图标，之后替换回来使用本地图标文件
    // });
  }, []);

  var renderIconFont = function renderIconFont() {
    if (round) extraClassName += " is-round";
    return /*#__PURE__*/_react.default.createElement("i", _extends({
      className: (0, _classnames.default)("specicon", "specicon-font", noPrefix ? '' : "".concat(prefix, "font"), noPrefix ? "".concat(name) : "".concat(prefix, "-").concat(name), extraClassName, name === 'loading' ? 'anticon-spin' : '', className),
      title: title,
      onClick: onClick,
      style: _objectSpread(_objectSpread({}, fontStyle), style),
      ref: ref
    }, otherProps));
  };

  var renderIconSvg = function renderIconSvg() {
    var baseElement = function baseElement() {
      return /*#__PURE__*/_react.default.createElement("i", _extends({
        className: (0, _classnames.default)("specicon", 'anticon', noPrefix ? "".concat(name, "-svg") : "".concat(prefix, "-").concat(name, "-svg"), !round && extraClassName, className),
        style: _objectSpread(_objectSpread({}, fontStyle), style),
        title: title,
        onClick: onClick,
        ref: ref
      }, otherProps), /*#__PURE__*/_react.default.createElement("svg", {
        width: "1em",
        height: "1em",
        fill: "currentColor",
        "aria-hidden": "true",
        focusable: "false",
        className: name === 'loading' ? 'anticon-spin' : ''
      }, noPrefix ? /*#__PURE__*/_react.default.createElement("use", {
        xlinkHref: "#".concat(name)
      }) : /*#__PURE__*/_react.default.createElement("use", {
        xlinkHref: "#".concat(prefix, "-").concat(name)
      })));
    };

    return round ? /*#__PURE__*/_react.default.createElement("span", {
      className: (0, _classnames.default)('specicon-round', status && " is-".concat(status))
    }, baseElement()) : baseElement();
  }; // 去除引入 font图标


  return type === 'colour' ? renderIconSvg() : renderIconFont();
});

var _default = SpecIcon;
exports.default = _default;