"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/es/spin/style");

var _spin = _interopRequireDefault(require("antd/es/spin"));

require("./index.less");

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _SplitterLayout = _interopRequireDefault(require("../SplitterLayout"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var SubfieldContent = function SubfieldContent(props) {
  var _props$leftSiderWidth = props.leftSiderWidth,
      leftSiderWidth = _props$leftSiderWidth === void 0 ? 180 : _props$leftSiderWidth,
      leftSiderNode = props.leftSiderNode,
      children = props.children,
      className = props.className,
      style = props.style,
      leftSiderClassName = props.leftSiderClassName,
      _props$loading = props.loading,
      loading = _props$loading === void 0 ? false : _props$loading,
      loadingTip = props.loadingTip,
      splitterlayout = props.splitterlayout,
      splitterProps = props.splitterProps;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)('spec-grid-content', loading ? 'spec-grid-content-loading' : '', className),
    style: style
  }, loading && /*#__PURE__*/_react.default.createElement(_spin.default, {
    spinning: loading,
    tip: loadingTip
  }), splitterlayout ? /*#__PURE__*/_react.default.createElement(_SplitterLayout.default, _extends({
    partClassNames: ["".concat((0, _classnames.default)('spec-grid-left', leftSiderClassName)), 'spec-grid-right'],
    primaryMinSize: leftSiderWidth || 180,
    primaryInitialSize: leftSiderWidth || 180
  }, splitterProps), /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, leftSiderNode), /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, children)) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)('spec-grid-left', leftSiderClassName),
    style: {
      width: "".concat(leftSiderWidth || 180, "px")
    }
  }, leftSiderNode), /*#__PURE__*/_react.default.createElement("div", {
    className: "spec-grid-right"
  }, children)));
};

var _default = SubfieldContent;
exports.default = _default;