"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/es/spin/style");

var _spin = _interopRequireDefault(require("antd/es/spin"));

require("./index.less");

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var WrapperContent = function WrapperContent(props) {
  var children = props.children,
      light = props.light,
      className = props.className,
      style = props.style,
      _props$noMargin = props.noMargin,
      noMargin = _props$noMargin === void 0 ? false : _props$noMargin,
      _props$loading = props.loading,
      loading = _props$loading === void 0 ? false : _props$loading,
      loadingTip = props.loadingTip;
  var defaultClassName = 'spec-wrapper-content';
  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)(defaultClassName, className, loading ? 'spec-wrapper-content-loading' : '', noMargin ? 'has-margin' : ''),
    style: style
  }, loading && /*#__PURE__*/_react.default.createElement(_spin.default, {
    spinning: loading,
    tip: loadingTip
  }), light ? /*#__PURE__*/_react.default.createElement("div", {
    className: "light-block"
  }, " ", children) : children);
};

var _default = WrapperContent;
exports.default = _default;