"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/es/button/style");

var _button = _interopRequireDefault(require("antd/es/button"));

require("antd/es/form/style");

var _form = _interopRequireDefault(require("antd/es/form"));

var _react = _interopRequireWildcard(require("react"));

var _FieldComponent = _interopRequireDefault(require("../FormComp/FieldComponent"));

var _ValueFormat = _interopRequireDefault(require("../utils/ValueFormat.js"));

var _index = _interopRequireDefault(require("../components/ButtonGroup/index.js"));

var _index2 = require("../data/index");

require("./index.less");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var FormItem = _form.default.Item;

var StandardFilter = /*#__PURE__*/function (_React$Component) {
  _inherits(StandardFilter, _React$Component);

  var _super = _createSuper(StandardFilter);

  _createClass(StandardFilter, null, [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      var formItemGroup = nextProps.formItemGroup; // const restOptionList = removeNoPermission(buttonGroup, permissionCodes, codes) || []

      return {
        // recombinationGroup: restOptionList,
        reFormItemGroup: formItemGroup
      };
    }
  }]);

  function StandardFilter(props) {
    var _this;

    _classCallCheck(this, StandardFilter);

    _this = _super.call(this, props);
    _this.filterFormRef = /*#__PURE__*/_react.default.createRef();

    _this.updateFormFields = function (newVal, force) {
      var getFormFields = _this.props.getFormFields;
      var resetValues = {};

      if (force) {
        // this.filterFormRef.current.resetFields()
        // 先清空 再赋值
        resetValues = _this.filterFormRef.current.getFieldsValue();
        Object.keys(resetValues).forEach(function (item) {
          resetValues[item] = undefined;
        });
      }

      _this.filterFormRef.current.setFieldsValue(_objectSpread(_objectSpread({}, resetValues), newVal)); // 直接清空表单的赋值


      if (getFormFields) getFormFields(_this.filterFormRef.current.getFieldsValue(), _this.filterFormRef);
    };

    _this.handleSearch = function (values) {
      var _this$props = _this.props,
          formItemGroup = _this$props.formItemGroup,
          onFilterSearch = _this$props.onFilterSearch; // if (Object.prototype.hasOwnProperty.call(values, false)) {
      //   delete values.false // TODO 自定义结构会莫名的出来一个false字段
      // }

      var resultValues = (0, _ValueFormat.default)(values, formItemGroup);

      if (onFilterSearch) {
        onFilterSearch(_objectSpread({}, resultValues));
      }
    };

    _this.handleReset = function () {
      var onFilterReset = _this.props.onFilterReset; // 使用此方法，表单校验无法清空掉
      // const resetValues = this.filterFormRef.current.getFieldsValue()
      // Object.keys(resetValues).forEach((item) => {
      //   resetValues[item] = undefined
      // })
      // this.filterFormRef.current.setFieldsValue({ ...resetValues }) // 直接清空表单的赋值

      _this.filterFormRef.current.resetFields();

      _this.setState({
        reFormItemGroup: _this.props.formItemGroup // 重新渲染列表

      });

      if (onFilterReset) {
        onFilterReset(_this.filterFormRef.current.getFieldsValue());
      }
    };

    _this.itemIsHide = function (isHide) {
      var current = _this.filterFormRef.current;
      if (!isHide) return false;

      if (typeof isHide === 'function') {
        return isHide(current ? current.getFieldsValue() : {}, current);
      }

      return isHide;
    };

    _this.renderFormItemGroup = function () {
      var reFormItemGroup = _this.state.reFormItemGroup;

      if (Array.isArray(reFormItemGroup)) {
        return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, reFormItemGroup.map(function (item, index) {
          var componentStyle = item.componentStyle,
              isHide = item.isHide;
          if (_this.itemIsHide(isHide)) return null;
          return /*#__PURE__*/_react.default.createElement(FormItem, _extends({
            key: item.filedName,
            label: item.label,
            name: item.type !== 'custom' && item.filedName,
            rules: item.rules || (item.fieldOptions ? item.fieldOptions.rules : [])
          }, item.protoFormItem), item.type === 'custom' && item.customRender ? item.customRender(_this.filterFormRef, _objectSpread({}, item)) : /*#__PURE__*/_react.default.createElement(_FieldComponent.default, _extends({}, item, {
            onChange: function onChange(val) {
              var updateValue = val;

              if (item.type === 'input' || item.type === 'textarea' || item.type === 'radio') {
                updateValue = val.target.value;
              }

              if (Array.isArray(val)) {
                updateValue = _toConsumableArray(val);
              }

              _this.updateFormFields(_defineProperty({}, item.filedName, updateValue));

              for (var _len = arguments.length, otherParams = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                otherParams[_key - 1] = arguments[_key];
              }

              if (item.onChange) item.onChange.apply(item, [val, _this.filterFormRef].concat(otherParams));
            },
            style: _objectSpread({
              width: item.type === 'checkbox' || item.type === 'radio' ? 'auto' : _index2.general.formItemStyle.xsm.width
            }, componentStyle)
          })));
        }));
      }

      return reFormItemGroup;
    };

    _this.state = {
      // recombinationGroup: [],
      reFormItemGroup: undefined
    };
    return _this;
  }

  _createClass(StandardFilter, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var initialValues = this.props.initialValues;
      this.updateFormFields(initialValues, true);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var initialValues = this.props.initialValues;

      if (prevProps.initialValues !== initialValues) {
        this.updateFormFields(initialValues, true);
      }
    } // 更新表单控件值，用于外部获取当前表单实例(force是否强制清空表单)

  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style,
          onFilterReset = _this$props2.onFilterReset,
          _this$props2$buttonGr = _this$props2.buttonGroup,
          buttonGroup = _this$props2$buttonGr === void 0 ? [] : _this$props2$buttonGr,
          min = _this$props2.min,
          codes = _this$props2.codes,
          permissionCodes = _this$props2.permissionCodes,
          initialValues = _this$props2.initialValues; // const { recombinationGroup } = this.state;

      return /*#__PURE__*/_react.default.createElement(_form.default, {
        name: "standard-filter-form",
        ref: this.filterFormRef,
        layout: "inline",
        onFinish: this.handleSearch,
        className: className,
        style: style // initialValues={{ ...initialValues }}

      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "filter-grid"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "filter-form"
      }, this.state.reFormItemGroup ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, this.renderFormItemGroup(), /*#__PURE__*/_react.default.createElement(FormItem, null, /*#__PURE__*/_react.default.createElement(_button.default, {
        type: "primary",
        htmlType: "submit"
      }, "\u67E5\u8BE2"), onFilterReset && /*#__PURE__*/_react.default.createElement(_button.default, {
        type: "primary",
        style: {
          marginLeft: 8
        },
        onClick: this.handleReset,
        ghost: true
      }, "\u91CD\u7F6E"))) : null), buttonGroup && buttonGroup.length > 0 ? /*#__PURE__*/_react.default.createElement("div", {
        className: "filter-btns"
      }, /*#__PURE__*/_react.default.createElement(_index.default, {
        options: buttonGroup,
        min: min,
        codes: codes,
        permissionCodes: permissionCodes
      })) : null));
    }
  }]);

  return StandardFilter;
}(_react.default.Component);

var _default = StandardFilter;
exports.default = _default;