"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/es/button/style");

var _button = _interopRequireDefault(require("antd/es/button"));

var _react = _interopRequireWildcard(require("react"));

var _IconNode = _interopRequireDefault(require("../components/IconNode"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ActionList = function ActionList(props) {
  var list = props.list,
      form = props.form,
      align = props.align,
      other = props.other,
      onStep = props.onStep;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "standardForm-actions",
    style: {
      textAlign: align
    }
  }, list.map(function (item, index) {
    return /*#__PURE__*/_react.default.createElement(_button.default, {
      key: index,
      type: item.type ? item.type : 'primary',
      icon: /*#__PURE__*/_react.default.createElement(_IconNode.default, {
        icon: item.icon
      }),
      ghost: item.ghost,
      disabled: item.disabled,
      loading: item.loading,
      onClick: function onClick(e) {
        if (item.action) {
          // 如果有配置默认执行方法，则优先以组件内部的步骤事件做处理
          onStep(item.action, function () {
            item.fn && item.fn(item, form, other, e);
          });
        } else if (item.fn) {
          item.fn(item, form, other, e);
        } else if (item.onClick) {
          item.onClick(item, form, other, e);
        }
      }
    }, item.name);
  }));
};

var _default = ActionList;
exports.default = _default;