"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/es/popconfirm/style");

var _popconfirm = _interopRequireDefault(require("antd/es/popconfirm"));

require("antd/es/dropdown/style");

var _dropdown = _interopRequireDefault(require("antd/es/dropdown"));

require("antd/es/button/style");

var _button = _interopRequireDefault(require("antd/es/button"));

require("antd/es/menu/style");

var _menu = _interopRequireDefault(require("antd/es/menu"));

var _react = _interopRequireWildcard(require("react"));

var _index = _interopRequireDefault(require("../IconNode/index"));

var _index2 = _interopRequireDefault(require("../../SpecIconFont/index"));

var _index3 = require("../../data/index");

var _icons = require("@ant-design/icons");

var _PopConfirmTitle = _interopRequireDefault(require("./PopConfirmTitle"));

var _filterPermission = require("../../utils/filterPermission.js");

require("./index.less");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var ButtonGroup = function ButtonGroup(props) {
  var _props$type = props.type,
      type = _props$type === void 0 ? 'button' : _props$type,
      _props$rowParams = props.rowParams,
      rowParams = _props$rowParams === void 0 ? {
    text: undefined,
    record: undefined,
    rowIndex: undefined
  } : _props$rowParams,
      _props$codes = props.codes,
      codes = _props$codes === void 0 ? _index3.funcCode.btnFuncCodes : _props$codes,
      permissionCodes = props.permissionCodes;
  var _props$options = props.options,
      options = _props$options === void 0 ? [] : _props$options,
      _props$min = props.min,
      min = _props$min === void 0 ? 3 : _props$min; // 最小展示长度不能小于2

  if (!options) return null; // 没有配置list返回null

  var _useState = (0, _react.useState)(-1),
      _useState2 = _slicedToArray(_useState, 2),
      popVisibleIndex = _useState2[0],
      setPopVisibleIndex = _useState2[1];

  var _useState3 = (0, _react.useState)({}),
      _useState4 = _slicedToArray(_useState3, 2),
      popRow = _useState4[0],
      setPopRow = _useState4[1];

  var _useState5 = (0, _react.useState)([]),
      _useState6 = _slicedToArray(_useState5, 2),
      resetList = _useState6[0],
      setResetList = _useState6[1];

  (0, _react.useEffect)(function () {
    // 重组选项options集合数据，排除：无权限（有配置code,并且不包含permissionCodes内）的数据及，isHide 为true的数据
    setResetList(_toConsumableArray((0, _filterPermission.removeNoPermission)(options, permissionCodes, codes, rowParams)) || []);
    return function () {
      setResetList([]);
    };
  }, [options, codes, permissionCodes]);
  (0, _react.useEffect)(function () {
    setPopVisibleIndex(-1);
  }, [rowParams]); // 渲染按钮多层级形式 (用于筛选)

  var buttonMenu = function buttonMenu(group) {
    return /*#__PURE__*/_react.default.createElement(_menu.default, null, group.map(function (item, index) {
      if (item.children) {
        return /*#__PURE__*/_react.default.createElement(_menu.default.SubMenu, {
          title: item.exName || item.name,
          key: index
        }, item.children.map(function (child, childIndex) {
          return /*#__PURE__*/_react.default.createElement(_menu.default.Item, {
            key: childIndex
          }, /*#__PURE__*/_react.default.createElement("a", {
            onClick: child.fn ? function () {
              return child.fn(child);
            } : null
          }, /*#__PURE__*/_react.default.createElement(_index.default, {
            icon: child.icon
          }), " ", child.exName || child.name));
        }));
      }

      return /*#__PURE__*/_react.default.createElement(_menu.default.Item, {
        key: index
      }, /*#__PURE__*/_react.default.createElement("a", {
        onClick: item.fn ? function () {
          return item.fn(item);
        } : null
      }, /*#__PURE__*/_react.default.createElement(_index.default, {
        icon: item.icon
      }), " ", item.exName || item.name));
    }));
  }; // 渲染按钮形式 (用于筛选)


  var RenderButtonList = function RenderButtonList(item) {
    if (Array.isArray(item.children) && item.children.length > 0) {
      return /*#__PURE__*/_react.default.createElement(_dropdown.default, {
        overlay: buttonMenu(item.children),
        placement: "bottomRight"
      }, /*#__PURE__*/_react.default.createElement(_button.default, {
        type: "primary"
      }, item.exName || item.name, " ", /*#__PURE__*/_react.default.createElement(_index2.default, {
        name: "down"
      })));
    }

    return /*#__PURE__*/_react.default.createElement(_button.default, {
      type: item.type ? item.type : 'primary',
      danger: item.danger,
      icon: /*#__PURE__*/_react.default.createElement(_index.default, {
        icon: item.icon
      }),
      disabled: (0, _filterPermission.btnIsDisabled)(item.disabled, rowParams),
      onClick: item.fn ? function () {
        return item.fn(item);
      } : null
    }, item.exName || item.name);
  }; // 渲染文本形式多级菜单列表（用于表格）


  var textMenu = function textMenu(group) {
    return /*#__PURE__*/_react.default.createElement(_menu.default, {
      className: "spec-button-text-dropdown"
    }, group.map(function (gItem, gIndex) {
      if (gItem.children) {
        return /*#__PURE__*/_react.default.createElement(_menu.default.SubMenu, {
          title: gItem.exName || gItem.name,
          key: gItem
        }, gItem.children.map(function (child, childIndex) {
          return /*#__PURE__*/_react.default.createElement(_menu.default.Item, {
            key: childIndex
          }, /*#__PURE__*/_react.default.createElement("a", {
            onClick: child.fn ? function () {
              return child.fn.apply(child, _toConsumableArray(Object.keys(rowParams).map(function (pItem) {
                return rowParams[pItem];
              })));
            } : null
          }, child.render ? child.render.apply(child, _toConsumableArray(Object.keys(rowParams).map(function (pItem) {
            return rowParams[pItem];
          }))) : child.exName || child.name));
        }));
      }

      return /*#__PURE__*/_react.default.createElement(_menu.default.Item, {
        key: gIndex,
        disabled: (0, _filterPermission.btnIsDisabled)(gItem.disabled, rowParams)
      }, gItem.hasOwnProperty('confirmText') || gItem.hasOwnProperty('confirmConfig') ? /*#__PURE__*/_react.default.createElement("a", {
        disabled: (0, _filterPermission.btnIsDisabled)(gItem.disabled, rowParams),
        onClick: gItem.fn ? function () {
          setPopVisibleIndex(rowParams.rowIndex);
          setPopRow(gItem);
        } : null
      }, " ", gItem.render ? gItem.render.apply(gItem, _toConsumableArray(Object.keys(rowParams).map(function (pItem) {
        return rowParams[pItem];
      }))) : gItem.exName || gItem.name) : /*#__PURE__*/_react.default.createElement("a", {
        className: "spec-button-group-text",
        onClick: gItem.fn ? function () {
          return gItem.fn.apply(gItem, _toConsumableArray(Object.keys(rowParams).map(function (pItem) {
            return rowParams[pItem];
          })));
        } : null,
        disabled: (0, _filterPermission.btnIsDisabled)(gItem.disabled, rowParams)
      }, gItem.render ? gItem.render.apply(gItem, _toConsumableArray(Object.keys(rowParams).map(function (pItem) {
        return rowParams[pItem];
      }))) : gItem.exName || gItem.name));
    }));
  }; // 渲染文本形式 列表（用于表格）


  var RenderTextList = function RenderTextList(item) {
    if (Array.isArray(item.children) && item.children.length > 0) {
      return /*#__PURE__*/_react.default.createElement(_dropdown.default, {
        overlay: textMenu(item.children),
        placement: "bottomRight"
      }, /*#__PURE__*/_react.default.createElement("a", {
        className: "spec-button-group-text"
      }, item.render ? item.render.apply(item, _toConsumableArray(Object.keys(rowParams).map(function (pItem) {
        return rowParams[pItem];
      }))) : item.exName || item.name, " ", /*#__PURE__*/_react.default.createElement(_index2.default, {
        name: "down"
      })));
    }

    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, item.hasOwnProperty('confirmText') || item.hasOwnProperty('confirmConfig') ? /*#__PURE__*/_react.default.createElement(_popconfirm.default, _extends({
      placement: "topRight",
      icon: /*#__PURE__*/_react.default.createElement(_icons.QuestionCircleOutlined, null)
    }, item.hasOwnProperty('confirmConfig') ? item.confirmConfig : {}, {
      // 弹出扩展配置
      title: /*#__PURE__*/_react.default.createElement(_PopConfirmTitle.default, _extends({}, item, {
        extraRow: rowParams
      })),
      onCancel: function onCancel() {
        if (item.hasOwnProperty('confirmConfig') && item.confirmConfig.onCancel) {
          var _item$confirmConfig;

          (_item$confirmConfig = item.confirmConfig).onCancel.apply(_item$confirmConfig, _toConsumableArray(Object.keys(rowParams).map(function (pItem) {
            return rowParams[pItem];
          })));
        }
      },
      onConfirm: function onConfirm() {
        if (item.hasOwnProperty('confirmConfig') && item.confirmConfig.onConfirm) {
          var _item$confirmConfig2;

          (_item$confirmConfig2 = item.confirmConfig).onConfirm.apply(_item$confirmConfig2, _toConsumableArray(Object.keys(rowParams).map(function (pItem) {
            return rowParams[pItem];
          })));
        } else if (item.fn) {
          item.fn.apply(item, _toConsumableArray(Object.keys(rowParams).map(function (pItem) {
            return rowParams[pItem];
          })));
        }
      }
    }), /*#__PURE__*/_react.default.createElement("a", {
      className: "spec-button-group-text",
      key: item.index,
      title: item.exName || item.name,
      disabled: (0, _filterPermission.btnIsDisabled)(item.disabled, rowParams)
    }, item.render ? item.render.apply(item, _toConsumableArray(Object.keys(rowParams).map(function (pItem) {
      return rowParams[pItem];
    }))) : item.exName || item.name)) : /*#__PURE__*/_react.default.createElement("a", {
      className: "spec-button-group-text",
      title: item.exName || item.name,
      key: item.index,
      disabled: (0, _filterPermission.btnIsDisabled)(item.disabled, rowParams),
      onClick: item.fn ? function () {
        return item.fn.apply(item, _toConsumableArray(Object.keys(rowParams).map(function (pItem) {
          return rowParams[pItem];
        })));
      } : null
    }, item.render ? item.render.apply(item, _toConsumableArray(Object.keys(rowParams).map(function (pItem) {
      return rowParams[pItem];
    }))) : item.exName || item.name));
  }; // 渲染展示的按钮列表


  var renderDisplayButton = function renderDisplayButton(item, index) {
    if (item.render) {
      return typeof item.render === 'function' ? item.render.apply(item, _toConsumableArray(Object.keys(rowParams).map(function (pItem) {
        return rowParams[pItem];
      }))) : item.render;
    }

    if (type === 'button') {
      /*渲染按钮形式*/
      return /*#__PURE__*/_react.default.createElement(RenderButtonList, _extends({
        key: index
      }, item));
    }
    /*渲染文本形式*/


    return /*#__PURE__*/_react.default.createElement(RenderTextList, _extends({
      key: index
    }, item));
    /* return <span key={index}>
       {
         // index !== 0 && <Divider type="vertical" />
       }
       <RenderTextList index={index} {...item}></RenderTextList></span>*/
  };

  if (min < 2) min = 2;
  if (resetList.length === 0) return type !== 'button' ? '-' : null;

  if (resetList.length > min) {
    var forGroup = resetList.slice(0, min - 1);
    var forDrop = resetList.slice(min - 1);
    return /*#__PURE__*/_react.default.createElement("span", {
      className: "spec-button-group"
    }, forGroup.map(function (item, index) {
      return index < min - 1 ? renderDisplayButton(item, index) : null;
    }), type === 'button' ? /*#__PURE__*/_react.default.createElement(_dropdown.default, {
      overlay: buttonMenu(forDrop),
      placement: "bottomRight"
    }, /*#__PURE__*/_react.default.createElement(_button.default, {
      type: "primary"
    }, "\u66F4\u591A ", /*#__PURE__*/_react.default.createElement(_index2.default, {
      name: "down"
    }))) : /*#__PURE__*/_react.default.createElement(_popconfirm.default, _extends({
      placement: "topRight",
      visible: popVisibleIndex === rowParams.rowIndex,
      icon: /*#__PURE__*/_react.default.createElement(_icons.QuestionCircleOutlined, null),
      trigger: "click"
    }, popRow.hasOwnProperty('confirmConfig') ? popRow.confirmConfig : {}, {
      // 弹出扩展配置
      title: /*#__PURE__*/_react.default.createElement(_PopConfirmTitle.default, _extends({}, popRow, {
        extraRow: rowParams
      })),
      onCancel: function onCancel() {
        setPopVisibleIndex(-1); // 优先调用其 confirmConfig 配置的 onCancel 事件

        if (popRow.hasOwnProperty('confirmConfig') && popRow.confirmConfig.onCancel) {
          var _popRow$confirmConfig;

          (_popRow$confirmConfig = popRow.confirmConfig).onCancel.apply(_popRow$confirmConfig, _toConsumableArray(Object.keys(rowParams).map(function (pItem) {
            return rowParams[pItem];
          })));
        }
      },
      onConfirm: function onConfirm() {
        setPopVisibleIndex(-1); // 优先调用其 confirmConfig 配置的 onConfirm 事件

        if (popRow.hasOwnProperty('confirmConfig') && popRow.confirmConfig.onConfirm) {
          var _popRow$confirmConfig2;

          (_popRow$confirmConfig2 = popRow.confirmConfig).onConfirm.apply(_popRow$confirmConfig2, _toConsumableArray(Object.keys(rowParams).map(function (pItem) {
            return rowParams[pItem];
          })));
        } else if (popRow.fn) {
          popRow.fn.apply(popRow, _toConsumableArray(Object.keys(rowParams).map(function (pItem) {
            return rowParams[pItem];
          })));
        }
      }
    }), /*#__PURE__*/_react.default.createElement(_dropdown.default, {
      overlay: textMenu(forDrop),
      placement: "bottomRight"
    }, /*#__PURE__*/_react.default.createElement("a", {
      className: "spec-button-group-text"
    }, "\u66F4\u591A ", /*#__PURE__*/_react.default.createElement(_icons.DownOutlined, null)))));
  }

  return /*#__PURE__*/_react.default.createElement("span", {
    className: "spec-button-group"
  }, resetList.map(function (item, index) {
    return renderDisplayButton(item, index);
  }));
};

var _default = ButtonGroup;
exports.default = _default;