function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

import "antd/es/button/style";
import _Button from "antd/es/button";
import "antd/es/input/style";
import _Input from "antd/es/input";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import React, { Component } from 'react';
import classNames from 'classnames'; // import styles from './component.less';

var EditButton = /*#__PURE__*/function (_Component) {
  _inherits(EditButton, _Component);

  var _super = _createSuper(EditButton);

  function EditButton(props) {
    var _this;

    _classCallCheck(this, EditButton);

    _this = _super.call(this, props);

    _this.handleClick = function () {
      _this.setState({
        inputVisible: true
      }, function () {
        return _this.input.focus();
      });
    };

    _this.saveInputRef = function (input) {
      _this.input = input;
    };

    _this.handleInputChange = function (e) {
      _this.setState({
        inputValue: e.target.value
      });
    };

    _this.handleInputConfirm = function (e) {
      var onSave = _this.props.onSave;
      if (onSave && e.target.value) onSave(e.target.value);

      _this.setState({
        inputVisible: false,
        inputValue: ''
      });
    };

    _this.state = {
      inputValue: '',
      inputVisible: false
    };
    return _this;
  }

  _createClass(EditButton, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          size = _this$props.size,
          label = _this$props.label,
          style = _this$props.style,
          className = _this$props.className,
          disabled = _this$props.disabled;
      var _this$state = this.state,
          inputValue = _this$state.inputValue,
          inputVisible = _this$state.inputVisible;
      return /*#__PURE__*/React.createElement("span", {
        style: _objectSpread({
          display: 'inline-block',
          width: '106px',
          verticalAlign: 'middle'
        }, style),
        className: classNames(className, 'spec-edit-button')
      }, inputVisible ? /*#__PURE__*/React.createElement(_Input, {
        ref: this.saveInputRef,
        type: "text",
        size: size,
        style: {
          width: '100%'
        },
        value: inputValue,
        onChange: this.handleInputChange,
        onBlur: this.handleInputConfirm,
        onPressEnter: this.handleInputConfirm
      }) : /*#__PURE__*/React.createElement(_Button, {
        disabled: disabled,
        icon: "plus",
        size: size,
        style: {
          borderStyle: 'dashed',
          width: '100%'
        },
        onClick: this.handleClick
      }, label));
    }
  }]);

  return EditButton;
}(Component);

export default EditButton;