import "antd/es/spin/style";
import _Spin from "antd/es/spin";
import './index.less';
import React from 'react';
import classNames from 'classnames';

var WrapperContent = function WrapperContent(props) {
  var children = props.children,
      light = props.light,
      className = props.className,
      style = props.style,
      _props$noMargin = props.noMargin,
      noMargin = _props$noMargin === void 0 ? false : _props$noMargin,
      _props$loading = props.loading,
      loading = _props$loading === void 0 ? false : _props$loading,
      loadingTip = props.loadingTip;
  var defaultClassName = 'spec-wrapper-content';
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(defaultClassName, className, loading ? 'spec-wrapper-content-loading' : '', noMargin ? 'has-margin' : ''),
    style: style
  }, loading && /*#__PURE__*/React.createElement(_Spin, {
    spinning: loading,
    tip: loadingTip
  }), light ? /*#__PURE__*/React.createElement("div", {
    className: "light-block"
  }, " ", children) : children);
};

export default WrapperContent;