function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

import "antd/es/modal/style";
import _Modal from "antd/es/modal";
import "antd/es/form/style";
import _Form from "antd/es/form";
import "antd/es/row/style";
import _Row from "antd/es/row";
import "antd/es/button/style";
import _Button from "antd/es/button";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import React, { useEffect, useState, useRef } from 'react';
import './index.less';
import { general } from '../data';
import RenderItemGroup from '../FormComp/RenderItemGroup';
import UtilValueFormat from '../utils/ValueFormat.js';
import IconNode from "../components/IconNode";
import UpdateFormRef from "./UpdateFormRef";

var StandardModal = /*#__PURE__*/function (_React$Component) {
  _inherits(StandardModal, _React$Component);

  var _super = _createSuper(StandardModal);

  _createClass(StandardModal, null, [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      var title = nextProps.title,
          footer = nextProps.footer,
          footerButtonGroup = nextProps.footerButtonGroup,
          hideFooter = nextProps.hideFooter,
          fieldStatus = nextProps.fieldStatus;
      return {
        bodyMaxHeight: "".concat(document.body.offsetHeight - (title ? 55 : 0) - (footer || footerButtonGroup ? 55 : 0) - 160 - 32 + (fieldStatus && fieldStatus !== 'default' || hideFooter ? 55 : 0), "px")
      };
    }
  }]);

  function StandardModal(props) {
    var _this;

    _classCallCheck(this, StandardModal);

    _this = _super.call(this, props);
    _this.modalFormRef = /*#__PURE__*/React.createRef();

    _this.initBodyMaxHeight = function () {
      var _this$props = _this.props,
          title = _this$props.title,
          footer = _this$props.footer,
          footerButtonGroup = _this$props.footerButtonGroup,
          hideFooter = _this$props.hideFooter,
          fieldStatus = _this$props.fieldStatus;

      _this.setState({
        bodyMaxHeight: "".concat(document.body.offsetHeight - (title ? 55 : 0) - (footer || footerButtonGroup ? 55 : 0) - 160 - 32 + (fieldStatus && fieldStatus !== 'default' || hideFooter ? 55 : 0), "px")
      });
    };

    _this.handleSubmit = function () {
      var _this$props2 = _this.props,
          type = _this$props2.type,
          formItemGroup = _this$props2.formItemGroup,
          onSubmit = _this$props2.onSubmit;

      if (type === 'form') {
        _this.modalFormRef.current.validateFields().then(function (values) {
          if (Object.prototype.hasOwnProperty.call(values, false)) {
            delete values.false; // TODO 自定义结构会莫名的出来一个false字段
          }

          var resultValues = UtilValueFormat(values, formItemGroup);

          if (onSubmit) {
            onSubmit(_objectSpread({}, resultValues)); // this.clearAllFieldsValue()
          }
        }).catch(function (errorInfo) {// TODO 滚动条需要滚动定位到第一条数据 label for=`modal-form_${errorInfo.errorFields[0].name}`
          // console.log('表单填写有误', errorInfo, '第一条数据', `modal-form_${errorInfo.errorFields[0].name}`)
        });
      } else {
        // 没有表单数组 formItemGroup 配置
        onSubmit && onSubmit();
      }
    };

    _this.clearAllFieldsValue = function () {// let allFields = {}
      // Object.keys(this.modalFormRef.getFieldsValue()).map((item) => allFields[item] = undefined)
      // this.modalFormRef.setFieldsValue(allFields) // 直接清空表单的赋值(initialValues传值如果没有前后赋值没有全部带上所有字段，则会默认又使用之前的部分未传参字段)
      // this.modalFormRef.current.resetFields()
    };

    _this.onAfterClose = function () {
      var afterClose = _this.props.afterClose; // if (type === 'form') this.clearAllFieldsValue()

      if (afterClose) afterClose();
    };

    _this.handleCancel = function () {
      var onCancel = _this.props.onCancel; // if (type === 'form') this.clearAllFieldsValue()

      if (onCancel) onCancel();
    };

    _this.renderButtonGroup = function () {
      var _this$props3 = _this.props,
          _this$props3$hideFoot = _this$props3.hideFooter,
          hideFooter = _this$props3$hideFoot === void 0 ? false : _this$props3$hideFoot,
          footerButtonGroup = _this$props3.footerButtonGroup,
          confirmLoading = _this$props3.confirmLoading,
          cancelText = _this$props3.cancelText,
          confirmText = _this$props3.confirmText,
          okText = _this$props3.okText;
      if (hideFooter) return null;

      if (footerButtonGroup) {
        if (Array.isArray(footerButtonGroup)) {
          if (footerButtonGroup.length === 0) return null;
          return /*#__PURE__*/React.createElement(React.Fragment, null, footerButtonGroup.map(function (item) {
            return /*#__PURE__*/React.createElement(_Button, {
              key: item.name,
              type: item.type ? item.type : 'primary',
              icon: /*#__PURE__*/React.createElement(IconNode, {
                icon: item.icon
              }),
              ghost: item.ghost,
              disabled: item.disabled,
              loading: item.loading,
              onClick: item.fn ? function (e) {
                return item.fn(item, _this.modalFormRef.current, _this.props, e);
              } : null
            }, item.name);
          }));
        } else {
          return footerButtonGroup;
        }
      }

      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_Button, {
        key: "submit",
        type: "primary",
        loading: confirmLoading,
        onClick: _this.handleSubmit
      }, confirmText || okText || '确定'), /*#__PURE__*/React.createElement(_Button, {
        key: "back",
        onClick: _this.handleCancel
      }, cancelText || '取消'));
    };

    _this.renderFormItemGroup = function () {
      var _this$props4 = _this.props,
          fieldStatus = _this$props4.fieldStatus,
          formItemGroup = _this$props4.formItemGroup,
          _this$props4$size = _this$props4.size,
          size = _this$props4$size === void 0 ? 'md' : _this$props4$size,
          displayLayout = _this$props4.displayLayout;

      if (Array.isArray(formItemGroup)) {
        return /*#__PURE__*/React.createElement(RenderItemGroup, {
          size: size,
          displayLayout: displayLayout,
          itemGroup: formItemGroup,
          fieldStatus: fieldStatus,
          getFormFields: _this.updateFormRef,
          form: _this.modalFormRef.current
        });
      }

      return formItemGroup;
    };

    _this.updateFormRef = function (fields, form) {
      var getFormFields = _this.props.getFormFields;

      _this.setState({
        modalFormFields: fields,
        modalForm: form
      });

      getFormFields && getFormFields(fields, form, _this.props);
    };

    _this.state = {
      // 160px代表上下空白间距， 32px为内容区内部的上下padding值
      bodyMaxHeight: "auto",
      modalFormFields: {},
      modalForm: {
        getFieldValue: function getFieldValue() {}
      }
    };
    return _this;
  }

  _createClass(StandardModal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      window.addEventListener('resize', this.initBodyMaxHeight);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props5 = this.props,
          hideFooter = _this$props5.hideFooter,
          fieldStatus = _this$props5.fieldStatus,
          title = _this$props5.title;
      if (hideFooter !== prevProps.hideFooter || fieldStatus !== prevProps.fieldStatus) this.initBodyMaxHeight();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.initBodyMaxHeight);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props6 = this.props,
          children = _this$props6.children,
          className = _this$props6.className,
          style = _this$props6.style,
          _this$props6$size = _this$props6.size,
          size = _this$props6$size === void 0 ? 'md' : _this$props6$size,
          type = _this$props6.type,
          formItemGroup = _this$props6.formItemGroup,
          title = _this$props6.title,
          visible = _this$props6.visible,
          formPrefix = _this$props6.formPrefix,
          formPostfix = _this$props6.formPostfix,
          initialValues = _this$props6.initialValues,
          hideRequiredMark = _this$props6.hideRequiredMark,
          footer = _this$props6.footer,
          bodyStyle = _this$props6.bodyStyle,
          _this$props6$fieldSta = _this$props6.fieldStatus,
          fieldStatus = _this$props6$fieldSta === void 0 ? 'default' : _this$props6$fieldSta;
      return /*#__PURE__*/React.createElement(_Modal, _extends({
        maskClosable: false,
        destroyOnClose: true
      }, this.props, {
        visible: visible,
        title: title,
        width: general.modalSize[size].width || general.modalSize.sm.width,
        footer: fieldStatus === 'viewOnly' || fieldStatus === 'disabled' ? false : this.renderButtonGroup() || footer,
        className: "standardModal ".concat(className || '', " ").concat(fieldStatus === 'viewOnly' ? 'is-view' : ''),
        style: _objectSpread({
          top: '80px'
        }, style),
        bodyStyle: _objectSpread({
          maxHeight: this.state.bodyMaxHeight,
          overflowY: 'scroll'
        }, bodyStyle),
        onCancel: this.handleCancel,
        afterClose: this.onAfterClose,
        onOk: this.handleSubmit
      }), children, type === 'form' && /*#__PURE__*/React.createElement(_Form, {
        ref: this.modalFormRef,
        onFinish: this.handleSubmit,
        hideRequiredMark: fieldStatus === 'viewOnly' || hideRequiredMark,
        scrollToFirstError: true,
        className: "modalForm"
      }, /*#__PURE__*/React.createElement(_Row, {
        type: "flex"
      }, formPrefix && formPrefix(this.state.modalForm, this.props), formItemGroup ? this.renderFormItemGroup() : null, formPostfix && formPostfix(this.state.modalForm, this.props)), /*#__PURE__*/React.createElement(UpdateFormRef, {
        getFormAndFields: this.updateFormRef,
        form: this.modalFormRef
      })));
    }
  }]);

  return StandardModal;
}(React.Component);

export default StandardModal;