"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var PopConfirmTitle = function PopConfirmTitle(propsData) {
  var confirmConfig = propsData.confirmConfig,
      confirmText = propsData.confirmText,
      extraRow = propsData.extraRow;

  if (confirmConfig && confirmConfig.title) {
    var title = confirmConfig.title;
    if (!title) return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, null);
    return typeof title === "function" ? title.apply(void 0, _toConsumableArray(Object.keys(extraRow).map(function (pItem) {
      return extraRow[pItem];
    }))) : title;
  }

  if (confirmText) {
    return typeof confirmText === "function" ? confirmText.apply(void 0, _toConsumableArray(Object.keys(extraRow).map(function (pItem) {
      return extraRow[pItem];
    }))) : confirmText;
  }

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, null);
};

var _default = PopConfirmTitle;
exports.default = _default;